diff --git a/src/vhdldocgen.cpp b/src/vhdldocgen.cpp
index d09de093..329dc898 100644
--- a/src/vhdldocgen.cpp
+++ b/src/vhdldocgen.cpp
@@ -714,6 +714,11 @@ static QMap<QCString,MemberDef*> varMap;
 static QList<ClassDef> qli;
 static QMap<ClassDef*,QList<ClassDef> > packages;
 
+
+
+///////
+
+
 MemberDef* VhdlDocGen::findMember(const QCString& className, const QCString& memName)
 {
   ClassDef* cd,*ecd;
@@ -728,6 +733,9 @@ MemberDef* VhdlDocGen::findMember(const QCString& className, const QCString& mem
   mdef=VhdlDocGen::findMemberDef(cd,memName,MemberListType_pubMethods);
   if (mdef) return mdef;
 
+
+
+
   // nothing found so far
   // if we are an architecture or package body search in entity
 
@@ -757,10 +765,11 @@ MemberDef* VhdlDocGen::findMember(const QCString& className, const QCString& mem
       if (mdef) return mdef;
       mdef=VhdlDocGen::findMemberDef(cd,memName,MemberListType_pubMethods);
       if (mdef) return mdef;
-    }
+     }
    }
 
 
+
   if ((VhdlDocGen::VhdlClasses)cd->protection()==VhdlDocGen::ARCHITECTURECLASS ||
       (VhdlDocGen::VhdlClasses)cd->protection()==VhdlDocGen::PACKBODYCLASS)
   {
@@ -804,6 +813,7 @@ MemberDef* VhdlDocGen::findMember(const QCString& className, const QCString& mem
         if (mdef) return mdef;
       }
 	  }
+	  qli.append(cd);
   return 0;
 
 }//findMember
@@ -833,8 +843,7 @@ MemberDef* VhdlDocGen::findMemberDef(ClassDef* cd,const QCString& key,MemberList
     return 0;
   }
   ml=cd->getMemberList(type);
-  qli.append(cd);
-  if (!ml)
+   if (!ml)
   {
     return 0;
   }
@@ -863,6 +872,8 @@ MemberDef* VhdlDocGen::findMemberDef(ClassDef* cd,const QCString& key,MemberList
   return 0;
 }//findMemberDef
 
+
+
 /*!
  * finds all included packages of an Entity or Package
  */
diff --git a/vhdlparser/vhdlparser.jj b/vhdlparser/vhdlparser.jj
index d21afe15..fb8a2863 100644
--- a/vhdlparser/vhdlparser.jj
+++ b/vhdlparser/vhdlparser.jj
@@ -658,12 +658,13 @@ QCString character_literal() :  {Token *tok=0;}
 
 QCString choice() : {QCString s;}
 {
-  LOOKAHEAD(discrete_range())
-  s=discrete_range(){ return s; }
-  |
-   LOOKAHEAD(simple_expression())
+     LOOKAHEAD(simple_expression())
    s=simple_expression(){ return s; }
   |
+ 
+   LOOKAHEAD(discrete_range())
+  s=discrete_range(){ return s; }
+  |
   LOOKAHEAD(identifier())
   s=identifier(){ return s; }
   | <OTHER_T> { return " others "; }
